searchNodes=[{"ref":"Limitex.html","title":"Limitex","type":"module","doc":"A pure Elixir distributed rate limiter based on Token Bucket algorithm."},{"ref":"Limitex.html#check_rate/4","title":"Limitex.check_rate/4","type":"function","doc":"See Limitex.RateLimiter.check_rate/4."},{"ref":"Limitex.RateLimiter.html","title":"Limitex.RateLimiter","type":"module","doc":"A distributed rate limiter for expensive requests based on Token Bucket algorithm."},{"ref":"Limitex.RateLimiter.html#check_rate/4","title":"Limitex.RateLimiter.check_rate/4","type":"function","doc":"Check if the action you wish to perform is within the bounds of the rate-limit. id: String name of the bucket. Usually comprised of a fixed prefix and some dynamic string appended scale_ms: Integer indicating size of bucket in milliseconds limit: Integer maximum count of actions within the bucket Example: user_id = 42076 case check_rate(&quot;file_upload:\#{user_id}&quot;, 60_000, 5) do {:ok, _count} -&gt; # do the file upload {:error, :rate_limited} -&gt; # render an error page or something end"},{"ref":"Limitex.RateLimiter.html#child_spec/1","title":"Limitex.RateLimiter.child_spec/1","type":"function","doc":"Returns a specification to start this module under a supervisor. See Supervisor."},{"ref":"Limitex.RateLimiter.html#t:bucket_info/0","title":"Limitex.RateLimiter.bucket_info/0","type":"type","doc":""},{"ref":"Limitex.RateLimiter.html#t:bucket_key/0","title":"Limitex.RateLimiter.bucket_key/0","type":"type","doc":""},{"ref":"readme.html","title":"Limitex","type":"extras","doc":"Limitex A pure Elixir distributed rate limiter based on the Token Bucket algorithm."},{"ref":"readme.html#description","title":"Limitex - Description","type":"extras","doc":"Limitex uses sharded ETS tables with write and read concurrency enabled, node clustering is not handled by this package, something like libcluster is recomended. Example =&gt; Limitex.check_rate(&quot;127.0.0.1&quot;, 60_000, 2) {:ok, 1} =&gt; Limitex.check_rate(&quot;127.0.0.1&quot;, 60_000, 2) {:ok, 2} =&gt; Limitex.check_rate(&quot;127.0.0.1&quot;, 60_000, 2) {:error, :rate_limited}"},{"ref":"readme.html#installation","title":"Limitex - Installation","type":"extras","doc":"You can find Limitex in Hex.pm and you can add it to your project dependencies: # mix.exs def deps do [ {:limitex, &quot;~&gt; 0.1.1&quot;} ] end"},{"ref":"readme.html#configuration","title":"Limitex - Configuration","type":"extras","doc":"Limitex will perform scheduled cleanups to remove expired buckets, to handle this, we should provide a cleanup interval and an expiry: # config.exs config :limitex, cleanup_interval: 60_000, # 1 minute (defaults to 5 minutes) expiry: 300_000 # 5 minutes (defaults to 15 minutes) Table cleanups will be scheduled every minute in this example (defaults to 5 minutes), and will delete buckets where expiry has already passed, it&#39;s important to give a value greater than the biggest bucket we create (the bucket_time param in check_rate function, see below). So if we&#39;re creating a bucket of 1 hour: Limitex.check_rate(&quot;some_id&quot;, 3_600_000, 20) we should give a bigger number in our config to prevent cleanup to delete buckets which are not yet expired: # config.exs config :limitex, expiry: 3_800_000 expiry defaults to 15 minutes."},{"ref":"readme.html#usage","title":"Limitex - Usage","type":"extras","doc":"Limitex exports a single function: check_rate/3 and check_rate/4. check_rate(id, bucket_time, limit) check_rate(id, bucket_time, limit, increment) which return an {:ok, count} or {:error, :rate_limited} tuples. Parameters id is a string to identify who&#39;s requesting the action, it can be composed of a unique part such as an IP address or a user ID, plus some action identifier (see example below). bucket_time is the amount of time you want to rate limit the action for the ID, must be given in milliseconds. limit is an integer which determines how many times we&#39;re allowed to perform the action in the given time. increment each time you call the function, the count to reach the limit is increased by 1 as a default, you can alternatively pass an arbitrary integer to increase the limit."},{"ref":"readme.html#examples","title":"Limitex - Examples","type":"extras","doc":"Inside your app you can call it inside any function: defmodule MyApp.Upload do def upload(video_data, user_id) do case Limitex.check_rate(&quot;upload:\#{user_id}&quot;, 60_000, 5) do {:ok, _count} -&gt; # upload the video, somehow {:error, :rate_limited} -&gt; # deny the request end end end So in the above example we&#39;ll limit user&#39;s uploads to 5 every 60 seconds."},{"ref":"readme.html#benchmarks","title":"Limitex - Benchmarks","type":"extras","doc":"Basic benchmarks can be run with mix bench. These benchmarks were run on an iMac 4 GHz Intel Core i7 w/ 32GB RAM. Name ips average deviation median 99th % check_rate (100,000) 388.48 K 2.57 μs ±892.63% 1.98 μs 4.98 μs check_rate (1,000,000) 395.01 K 2.53 μs ±898.74% 2 μs 4 μs"}]